#include <bits/stdc++.h>
using namespace std;
int masiv[1001][1001];
vector<pair<int,int>> dirr(4);
int main(){
    dirr[0]= { 0,1};
    dirr[1]= {1,0};
    dirr[2]={0,-1};
    dirr[3]={-1,0};
    int d=0;
    int m,n,p;
    cin>>m>>n>>p;
    for(int x=0,y=0;true;){
        //cout<<x<<" "<<y<<" "<<d<<endl;
        masiv[x][y]=m;
        if(x+dirr[d].first<n && y+dirr[d].second<n && x+dirr[d].first>=0 && y+dirr[d].second>=0 && masiv[x+dirr[d].first][y+dirr[d].second]==0){
            x+=dirr[d].first;
            y+=dirr[d].second;
        }else{
            d++;
            d%=4;
            x+=dirr[d].first;
            y+=dirr[d].second;
            if(masiv[x][y]!=0){
                break;
            }
        }
        m++;
        /*for(int i=0;i<n;i++){
            for(int j=0;j<n;j++){
                cout<<masiv[i][j]<<" ";
            }
            cout<<endl;
        }*/
    }
    int i=p-1,s=0;
    /*for(int i=0;i<n;i++){
            for(int j=0;j<n;j++){
                cout<<masiv[i][j]<<" ";
            }
            cout<<endl;
    }*/
    for(int j=0;j<n;j++){
        s+=masiv[i][j];
    }
    cout<<s<<endl;
    return 0;
}
